﻿namespace TabsStudioAfterClose
{
    class Tabs
    {
        public Tabs(TabsStudioExt.ITabsStudioEngine engine_, bool useActivateTabFocusWorkaround_)
        {
            engine = engine_;
            useActivateTabFocusWorkaround = useActivateTabFocusWorkaround_;
            isPreviewTabProperty = new AddinsCommon.IsPreviewTabProperty();
        }

        public uint Count()
        {
            TabsStudioExt.Tabs tabs = FindSelectedTabs();
            if (tabs == null)
                return 0;

            return (uint)GetVisibleTabs().Count;
        }

        // REQUIRE(i >= 0 && i < Count())
        public Tab GetTab(uint i)
        {
            return FindTab(GetVisibleTabs()[(int)i]);
        }

        // REQUIRE(Count() > 0)
        public Tab GetSelectedTab()
        {
            Group group = GetSelectedGroup();
            if (group == null)
                return null;

            return group.GetSelectedTab();
        }

        public Group GetSelectedGroup()
        {
            TabsStudioExt.Tabs tabs = FindSelectedTabs();
            if (tabs == null)
                return null;

            return new Group(tabs, useActivateTabFocusWorkaround);
        }

        public uint GetTabIndex(Tab tab)
        {
            uint result = 0;
            foreach (System.Windows.Controls.TabItem item in GetVisibleTabs())
            {
                if (tab.IsEqual(item))
                    break;
                ++result;
            }
            return result;
        }

        private TabsStudioExt.Tabs FindSelectedTabs()
        {
            foreach (TabsStudioExt.Tabs tabs in engine.ReturnTabs())
            {
                if (tabs.IsGroupSelected)
                    return tabs;
            }
            return null;
        }

        private System.Collections.Generic.List<System.Windows.Controls.TabItem> GetVisibleTabs()
        {
            System.Collections.Generic.List<System.Windows.Controls.TabItem> result =
                new System.Collections.Generic.List<System.Windows.Controls.TabItem>();
            foreach (System.Windows.UIElement i in FindSelectedTabs().TabPanel2.Children)
            {
                System.Windows.Controls.TabItem item = i as System.Windows.Controls.TabItem;
                if (!isPreviewTabProperty.IsPreviewTab(item) && item.Visibility == System.Windows.Visibility.Visible)
                    result.Add(item);
            }
            return result;
        }

        private Tab FindTab(System.Windows.Controls.TabItem item)
        {
            foreach (TabsStudioExt.Tab tab in FindSelectedTabs().TabList)
            {
                Tab result = new Tab(tab, useActivateTabFocusWorkaround);
                if (result.IsEqual(item))
                    return result;
            }
            return null;
        }

        private TabsStudioExt.ITabsStudioEngine engine;
        private bool useActivateTabFocusWorkaround;
        private AddinsCommon.IsPreviewTabProperty isPreviewTabProperty;
    }
}
